;PhysicEngine_3_Circle.au3
#include-once

Global $g_NumCircles = 0

Global $g_Circles_Position_X[1]
Global $g_Circles_Position_Y[1]
Global $g_Circles_Angle[1]
Global $g_Circles_Velocity_Linear_X[1]
Global $g_Circles_Velocity_Linear_Y[1]
Global $g_Circles_Velocity_Angular[1]
Global $g_Circles_Acceleration_Linear_X[1]
Global $g_Circles_Acceleration_Linear_Y[1]
Global $g_Circles_Acceleration_Angular[1]
Global $g_Circles_Force_Linear_X[1]
Global $g_Circles_Force_Linear_Y[1]
Global $g_Circles_Force_Angular[1]
Global $g_Circles_Mass[1]
Global $g_Circles_Tensor[1]
Global $g_Circles_Collision_Frequency[1]
Global $g_Circles_Box_X_Min[1]
Global $g_Circles_Box_X_Max[1]
Global $g_Circles_Box_Y_Min[1]
Global $g_Circles_Box_Y_Max[1]
Global $g_Circles_Radius[1]
Global $g_Circles_Color[1]
Global $g_Circles_Texture[1]
Global $g_Circles_Position_X_Last[1]
Global $g_Circles_Position_Y_Last[1]
Global $g_Circles_Angle_Last[1]
Global $g_Circles_Time_Without_Move[1]
Global $g_Circles_Sleep[1]

Func phys_CreateCircle( $radius, $position_x, $position_y, $angle, $velocity_linear_x, $velocity_linear_y, $velocity_angular, $mass, $tensor, $collision_fequency, $color, ByRef $texture )
		
	; redim arrays
		
	$g_NumCircles += 1;			// increase number of polygons / number der vielecke erhhen
	
	ReDim $g_Circles_Position_X[$g_NumCircles]
	ReDim $g_Circles_Position_Y[$g_NumCircles]
	ReDim $g_Circles_Angle[$g_NumCircles]
	ReDim $g_Circles_Velocity_Linear_X[$g_NumCircles]
	ReDim $g_Circles_Velocity_Linear_Y[$g_NumCircles]
	ReDim $g_Circles_Velocity_Angular[$g_NumCircles]
	ReDim $g_Circles_Acceleration_Linear_X[$g_NumCircles]
	ReDim $g_Circles_Acceleration_Linear_Y[$g_NumCircles]
	ReDim $g_Circles_Acceleration_Angular[$g_NumCircles]
	ReDim $g_Circles_Force_Linear_X[$g_NumCircles]
	ReDim $g_Circles_Force_Linear_Y[$g_NumCircles]
	ReDim $g_Circles_Force_Angular[$g_NumCircles]
	ReDim $g_Circles_Mass[$g_NumCircles]
	ReDim $g_Circles_Tensor[$g_NumCircles]
	ReDim $g_Circles_Collision_Frequency[$g_NumCircles]
	ReDim $g_Circles_Box_X_Min[$g_NumCircles]
	ReDim $g_Circles_Box_X_Max[$g_NumCircles]
	ReDim $g_Circles_Box_Y_Min[$g_NumCircles]
	ReDim $g_Circles_Box_Y_Max[$g_NumCircles]
	ReDim $g_Circles_Radius[$g_NumCircles]
	ReDim $g_Circles_Color[$g_NumCircles]
	ReDim $g_Circles_Texture[$g_NumCircles]
	ReDim  $g_Circles_Position_X_Last[$g_NumCircles]
	ReDim $g_Circles_Position_Y_Last[$g_NumCircles]
	ReDim $g_Circles_Angle_Last[$g_NumCircles]
	ReDim $g_Circles_Time_Without_Move[$g_NumCircles]
	ReDim $g_Circles_Sleep[$g_NumCircles]
		
	; set circle
		
	Local $CircleID = $g_NumCircles - 1

	$g_Circles_Position_X[$CircleID] = $position_x
	$g_Circles_Position_Y[$CircleID] = $position_y
	$g_Circles_Angle[$CircleID] = $angle
	$g_Circles_Velocity_Linear_X[$CircleID] = $velocity_linear_x
	$g_Circles_Velocity_Linear_Y[$CircleID] = $velocity_linear_y
	$g_Circles_Velocity_Angular[$CircleID] = $velocity_angular
	$g_Circles_Acceleration_Linear_X[$CircleID] = 0
	$g_Circles_Acceleration_Linear_Y[$CircleID] = 0
	$g_Circles_Acceleration_Angular[$CircleID] = 0
	$g_Circles_Force_Linear_X[$CircleID] = 0
	$g_Circles_Force_Linear_Y[$CircleID] = 0
	$g_Circles_Force_Angular[$CircleID] = 0
	$g_Circles_Mass[$CircleID] = $mass
	$g_Circles_Tensor[$CircleID] = $tensor
	$g_Circles_Collision_Frequency[$CircleID] = $collision_fequency
	$g_Circles_Box_X_Min[$CircleID] = $position_x
	$g_Circles_Box_X_Max[$CircleID] = $position_x
	$g_Circles_Box_Y_Min[$CircleID] = $position_y
	$g_Circles_Box_Y_Max[$CircleID] = $position_y
	$g_Circles_Radius[$CircleID] = $radius
	$g_Circles_Color[$CircleID] = $color
	$g_Circles_Texture[$CircleID] = $texture
	$g_Circles_Position_X_Last[$CircleID] = $position_x
	$g_Circles_Position_Y_Last[$CircleID] = $position_y
	$g_Circles_Angle_Last[$CircleID] = $angle
	$g_Circles_Time_Without_Move[$CircleID] = 0
	$g_Circles_Sleep[$CircleID] = (($mass = 0) And ($tensor = 0))
	
	Return $CircleID	
EndFunc

Func phys_UpdateCircles( $delta_t_s, $damping )
	For $i = 0 To $g_NumCircles - 1 Step 1 																												; loop all polygons
		$g_Circles_Velocity_Linear_X[$i] += $delta_t_s * $g_Circles_Force_Linear_X[$i] * (1/$g_Circles_Mass[$i])										; apply forces
		$g_Circles_Velocity_Linear_Y[$i] += $delta_t_s * $g_Circles_Force_Linear_Y[$i] * (1/$g_Circles_Mass[$i])
		$g_Circles_Velocity_Angular[$i] += $delta_t_s * $g_Circles_Force_Angular[$i] * (1/$g_Circles_Tensor[$i])
		
		$g_Circles_Velocity_Linear_X[$i] *= $damping
		$g_Circles_Velocity_Linear_Y[$i] *= $damping
		$g_Circles_Velocity_Angular[$i] *= $damping
		
		$g_Circles_Force_Linear_X[$i] = 0																												; reset to zero
		$g_Circles_Force_Linear_Y[$i] = 0
		$g_Circles_Force_Angular[$i] = 0
	
		$g_Circles_Position_X[$i] += $delta_t_s * $g_Circles_Velocity_Linear_X[$i]																		; update position
		$g_Circles_Position_Y[$i] += $delta_t_s * $g_Circles_Velocity_Linear_Y[$i]
		$g_Circles_Angle[$i] += $delta_t_s * $g_Circles_Velocity_Angular[$i] 																			; update angle
	Next
EndFunc

Func phys_CirclesApplyForces( $delta_t_s )
	For $i = 0 To $g_NumCircles - 1 Step 1 																												; loop all polygons
		If Not $g_Circles_Sleep[$i] Then
			If $g_Circles_Mass[$i] <> 0 Then 	
				$g_Circles_Velocity_Linear_X[$i] += $delta_t_s * $g_Circles_Force_Linear_X[$i] * (1/$g_Circles_Mass[$i])									; apply forces
				$g_Circles_Velocity_Linear_Y[$i] += $delta_t_s * $g_Circles_Force_Linear_Y[$i] * (1/$g_Circles_Mass[$i])
			EndIf
			If $g_Circles_Tensor[$i] <> 0 Then 
				$g_Circles_Velocity_Angular[$i] += $delta_t_s * $g_Circles_Force_Angular[$i] * (1/$g_Circles_Tensor[$i])
			EndIf
		EndIf
		
		$g_Circles_Force_Linear_X[$i] = 0																												; reset to zero
		$g_Circles_Force_Linear_Y[$i] = 0
		$g_Circles_Force_Angular[$i] = 0			
	Next
EndFunc

Func phys_CirclesUpdatePosition( $delta_t_s, $damping, $limit_sleep_pos_sq, $limit_sleep_angle, $limit_sleep_time )
	For $i = 0 To $g_NumCircles - 1 Step 1 																												; loop all polygons
		If Not $g_Circles_Sleep[$i] Then
			$g_Circles_Velocity_Linear_X[$i] *= $damping
			$g_Circles_Velocity_Linear_Y[$i] *= $damping
			$g_Circles_Velocity_Angular[$i] *= $damping
			
			$g_Circles_Position_X[$i] += $delta_t_s * $g_Circles_Velocity_Linear_X[$i]																		; update position
			$g_Circles_Position_Y[$i] += $delta_t_s * $g_Circles_Velocity_Linear_Y[$i]
			$g_Circles_Angle[$i] += $delta_t_s * $g_Circles_Velocity_Angular[$i] 																				; update angle
			
			Local $DeltaX = $g_Circles_Position_X_Last[$i] - $g_Circles_Position_X[$i]
			Local $DeltaY = $g_Circles_Position_Y_Last[$i] - $g_Circles_Position_Y[$i]
			Local $DistanceSQ = $DeltaX*$DeltaX + $DeltaY*$DeltaY
			Local $DeltaAngle = Abs( $g_Circles_Angle_Last[$i] - $g_Circles_Angle[$i])
			
			If ($DistanceSQ > $limit_sleep_pos_sq) Or ($DeltaAngle > $limit_sleep_angle) Then
				phys_CircleWake( $i )
			Else			
				If $g_Circles_Time_Without_Move[$i] >= $limit_sleep_time Then 
					$g_Circles_Sleep[$i] = True
				Else
					$g_Circles_Time_Without_Move[$i] += $delta_t_s	
				EndIf
			EndIf
		EndIf
	Next
EndFunc

Func phys_CircleAddForcePoint( $polygon_id, $point_x, $point_y, $force_x, $force_y )

	Local $DeltaX = $point_x - $g_Circles_Position_X[$polygon_id]
	Local $DeltaY = $point_y - $g_Circles_Position_Y[$polygon_id]
	Local $Radius = Sqrt($DeltaX * $DeltaX + $DeltaY * $DeltaY)
	
	If $Radius = 0 Then														; force is appied to center of polygon
		$g_Circles_Force_Linear_X[$polygon_id] += $force_x
		$g_Circles_Force_Linear_Y[$polygon_id] += $force_y
	Else
		Local $ForceLength = Sqrt($force_x * $force_x + $force_y * $force_y)
		If $ForceLength = 0 Then $ForceLength = 1
		
		Local $ForceNoramlizedX = $force_x / $ForceLength
		Local $ForceNoramlizedY = $force_y / $ForceLength
		
		Local $RadiusNormalizedX = $DeltaX / $Radius
		Local $RadiusNormalizedY = $DeltaY / $Radius
		
		Local $Lambda = $ForceNoramlizedX * $RadiusNormalizedX + $ForceNoramlizedY * $RadiusNormalizedY
		Local $LambdaAbs = Abs($Lambda)
		
		Local $ForceLinearX = $LambdaAbs * $force_x
		Local $ForceLinearY = $LambdaAbs * $force_y
		Local $ForceAngular = (1-$LambdaAbs) * $DeltaX * $force_y - $DeltaY * $force_x
		
		;ToolTip( "LinearForce: " & $ForceLinearX & " " & $ForceLinearY & " AngularForce: " & $ForceAngular )
		
		$g_Circles_Force_Linear_X[$polygon_id] += $ForceLinearX
		$g_Circles_Force_Linear_Y[$polygon_id] += $ForceLinearY		
		$g_Circles_Force_Angular[$polygon_id] += $ForceAngular
	EndIf
EndFunc

Func phys_CircleAddForceCenter( $circle_id, $force_x, $force_y )
	$g_Circles_Force_Linear_X[$circle_id] += $force_x
	$g_Circles_Force_Linear_Y[$circle_id] += $force_y
EndFunc

Func phys_IsPointInCircle( $circle_id, $point_x, $point_y )
	Return phys_PointInCircle( $point_x, $point_y, $g_Circles_Position_X[$circle_id], $g_Circles_Position_Y[$circle_id], $g_Circles_Radius[$circle_id] )
EndFunc

Func phys_CircleFromPoint( $point_x, $point_y, ByRef $circle_id )
	
	$circle_id = -1
	
	For $i = 0 To $g_NumCircles-1 Step 1
		
		If phys_IsPointInCircle( $i, $point_x, $point_y ) Then
			$circle_id = $i
			Return True
		EndIf
	Next

	Return False
EndFunc

Func phys_CircleGetRadiusPoint( $circle_id, $point_x, $point_y )
	Dim $Radius[2]

	$Radius[0] = $point_x - $g_Circles_Position_X[$circle_id]
	$Radius[1] = $point_y - $g_Circles_Position_Y[$circle_id]
	
	Return $Radius
EndFunc

Func phys_CircleStop( $circle_id )
	$g_Circles_Velocity_Linear_X[$circle_id] = 0
	$g_Circles_Velocity_Linear_Y[$circle_id] = 0
	$g_Circles_Velocity_Angular[$circle_id] = 0
EndFunc

Func phys_CircleSleep( $circle_id )
	$g_Circles_Sleep[$circle_id] = True
EndFunc

Func phys_CircleWake( $circle_id )
	If ($g_Circles_Mass[$circle_id] <> 0) Or ($g_Circles_Tensor[$circle_id] <> 0) Then
		$g_Circles_Position_X_Last[$circle_id] = $g_Circles_Position_X[$circle_id]
		$g_Circles_Position_Y_Last[$circle_id] = $g_Circles_Position_Y[$circle_id]
		$g_Circles_Angle_Last[$circle_id] = $g_Circles_Angle[$circle_id]
		$g_Circles_Time_Without_Move[$circle_id] = 0
		$g_Circles_Sleep[$circle_id] = False
	EndIf
EndFunc

Func phys_CircleGetInfomations( $circle_id )
		
	Return _ 
		"Informations Polygon " & $circle_id & ":" & @LF & @LF & _ 
		"   + Position: " & Round( $g_Circles_Position_X[$circle_id], 0 ) & " " & Round( $g_Circles_Position_Y[$circle_id], 0 ) & @LF & _ 
		"   + Angle: " & Round( $g_Circles_Angle[$circle_id] * $RAD_TO_DEG, 0 ) & "" & @LF & _
		"   + VelocityLinear: " & Round( $g_Circles_Velocity_Linear_X[$circle_id], 0 ) & " " & Round( $g_Circles_Velocity_Linear_Y[$circle_id], 0 ) & @LF & _ 
		"   + VelocityAngular: " & Round( $g_Circles_Velocity_Angular[$circle_id] * $RAD_TO_DEG, 0 ) & "/s" & @LF & _ 
		"   + TimeWithoutMove: " & Round(  $g_Circles_Time_Without_Move[$circle_id], 0 ) & "s" & @LF & _ 
		"   + Sleep: " & $g_Circles_Sleep[$circle_id]

EndFunc