;PhysicEngine_3_Draw.au3
#include-once

#include <WindowsConstants.au3>
#include <GDIPlus.au3>
#include <PhysicEngine_3_Opengl.au3>
#include <PhysicEngine_3_Polygon.au3>
#include <PhysicEngine_3_Circle.au3>

Enum $TEXTURE_HANDLE, $TEXTURE_WIDTH, $TEXTURE_HEIGHT

Global Const $COLOR_RED = 0xFFFF0000
Global Const $COLOR_GREEN = 0xFFFF0000
Global Const $COLOR_BLUE = 0xFFFF0000
Global Const $COLOR_YELLOW = 0xFFFF0000
Global Const $COLOR_BLACK = 0xFFFF0000
Global Const $COLOR_WHITE = 0xFFFF0000

;Global Const $SRCCOPY = 0x00CC0020

Global $g_hWindow = 0
Global $g_hWindow_Render = 0

Global $g_hDC = 0
Global $g_hGraphic = 0

Global $g_hDummyBitmap = 0
Global $g_hImage = 0
Global $g_hBitmap = 0

Global $g_hScrDC = 0
Global $g_Backbuffer_hDC = 0
Global $g_DC_obj = 0
Global $g_hBackbuffer = 0

Global $g_hFGBitmap = 0
Global $g_hFGBackbuffer = 0

Global $g_hPen = 0
Global $g_hBrush = 0
Global $g_hFont = 0
Global $g_hFormat = 0

Global $g_FGBitmapSize[2] = [2048, 2048]

Global $g_Window_X
Global $g_Window_Y
Global $g_Window_Width
Global $g_Window_Height
Global $g_Window_Title

Global Const $g_StandartFont = "Arial"

Global $g_OpenGL_DC = 0

;MsgBox(0,"","Size: " & $g_OpenGL_TextureWidth & "x" & $g_OpenGL_TextureHeight & " TextureID: " & $g_OpenGL_TextureID )

Func phys_StartupDraw()
	_GDIPlus_Startup()
	
	$g_hPen = _GDIPlus_PenCreate(0xFF000000, 1)
	$g_hBrush = _GDIPlus_BrushCreateSolid(0xFFABCDEF)
	Local $hFamily = _GDIPlus_FontFamilyCreate($g_StandartFont)
	$g_hFont = _GDIPlus_FontCreate($hFamily, 8) ; font size
	_GDIPlus_FontFamilyDispose($hFamily)
	$g_hFormat = _GDIPlus_StringFormatCreate(0) ; format
EndFunc

Func phys_ShutdownDraw()
	_GDIPlus_StringFormatDispose($g_hFormat)
	_GDIPlus_FontDispose($g_hFont)
	_GDIPlus_BrushDispose($g_hBrush)
	_GDIPlus_PenDispose($g_hPen)
	
	_GDIPlus_Shutdown()
EndFunc

Func phys_CreateWindow($title, $width, $height, $x = -1, $y = -1)
	$g_hWindow = GUICreate($title, $width, $height, $x, $y) ;, BitOR($WS_OVERLAPPEDWINDOW, $WS_CLIPSIBLINGS, $WS_CLIPCHILDREN), BitOR($WS_EX_APPWINDOW, $WS_EX_WINDOWEDGE))
	GUISetOnEvent(-3, "_phys_Exit")
	GUISetState(@SW_SHOW)
	
	;$g_hWindow_Render = GUICreate( "", $width, $height, 0, 0, BitOR($WS_CHILD, $WS_VISIBLE), $WS_EX_OVERLAPPEDWINDOW, $g_hWindow )
	;GUISetState(@SW_SHOW)
	
	;GUISetCursor(3) ; cross
	GUISetCursor(16, 1, $g_hWindow_Render) ; invisible
	
	Switch $PHYS_DRAW_MODE
		Case $RENDER_NULL
		Case $RENDER_GDIPLUS
			$g_hDC = _WinAPI_GetWindowDC($g_hWindow)
			$g_hGraphic = _GDIPlus_GraphicsCreateFromHDC($g_hDC)
			
			$g_hDummyBitmap = _WinAPI_CreateBitmap($width, $height)
			$g_hImage = _GDIPlus_BitmapCreateFromHBITMAP($g_hDummyBitmap)
			$g_hBitmap = _GDIPlus_BitmapCreateHBITMAPFromBitmap($g_hImage)
			
			$g_hScrDC = _WinAPI_GetDC(0)
			$g_Backbuffer_hDC = _WinAPI_CreateCompatibleDC($g_hScrDC)
			$g_DC_obj = _WinAPI_SelectObject($g_Backbuffer_hDC, $g_hBitmap)
			$g_hBackbuffer = _GDIPlus_GraphicsCreateFromHDC($g_Backbuffer_hDC)
			
			$g_FGBitmapSize[0] = $width
			$g_FGBitmapSize[1] = $height
			
			$g_hFGBitmap = _GDIPlus_BitmapCreateFromGraphics($g_FGBitmapSize[0], $g_FGBitmapSize[1], $g_hGraphic)
			$g_hFGBackbuffer = _GDIPlus_ImageGetGraphicsContext($g_hFGBitmap)
		Case $RENDER_OPENGL
			CreateOpenGLContext($g_hWindow, $g_OpenGL_DC)
			
			glEnable($GL_TEXTURE_2D)
			
			glMatrixMode($GL_PROJECTION)
			glLoadIdentity()
			glViewport(0, 0, $width, $height)
			
			glScalef(2/$width, -2/$height, 0)
			glTranslatef(-0.5*$width, -0.5*$height, 0)
			
			glMatrixMode($GL_MODELVIEW)
			glLoadIdentity()
		Case Else
			Return False
	EndSwitch
	
	$g_Window_X = $x
	$g_Window_Y = $y
	$g_Window_Width = $width
	$g_Window_Height = $height
	$g_Window_Title = $title
	
	phys_SwapBuffers()
EndFunc

Func _phys_Exit()
	Exit 0
EndFunc

Func phys_CreateTexture($filename)
	
	Switch $PHYS_DRAW_MODE
		Case $RENDER_NULL
		Case $RENDER_GDIPLUS
			Return _GDIPlus_CreateTexture($filename)
		Case $RENDER_OPENGL
			Return glCreateTextureFromFileFast($filename)
		Case Else
			Return False
	EndSwitch
	
EndFunc

Func phys_CreateTextureColor($color)
	
	Switch $PHYS_DRAW_MODE
		Case $RENDER_NULL
		Case $RENDER_GDIPLUS
			Return _GDIPlus_CreateTextureColor($color)
		Case $RENDER_OPENGL
			Return glCreateTextureFromColorFast($color)
		Case Else
			Return False
	EndSwitch
	
EndFunc

Func _GDIPlus_CreateTexture($filename)
	Local $ImageFromFile_Handle = _GDIPlus_ImageLoadFromFile($filename) ; load image from file / bild aus datei laden
	
	Local $ImageFromFile_Width = _GDIPlus_ImageGetWidth($ImageFromFile_Handle)
	Local $ImageFromFile_Height = _GDIPlus_ImageGetWidth($ImageFromFile_Handle)
	
	Local $aResult = DllCall($ghGDIPDll, "uint", "GdipCreateTexture2", "hwnd", $ImageFromFile_Handle, "int", 0, "float", 0, "float", 0, "float", $ImageFromFile_Width, "float", $ImageFromFile_Height, "int*", 0)
	
	_GDIPlus_ImageDispose($ImageFromFile_Handle)
	
	If @error Then Return SetError(@error, @extended, 0)
	
	Dim $Texture[3]
	
	$Texture[$TEXTURE_HANDLE] = $aResult[7]
	$Texture[$TEXTURE_WIDTH] = $ImageFromFile_Width
	$Texture[$TEXTURE_HEIGHT] = $ImageFromFile_Height
	
	Return $Texture
EndFunc

Func _GDIPlus_CreateTextureColor($color)
	Dim $Texture[3]
	
	$Texture[$TEXTURE_HANDLE] = _GDIPlus_BrushCreateSolid($color)
	$Texture[$TEXTURE_WIDTH] = 256
	$Texture[$TEXTURE_HEIGHT] = 256
	
	Return $Texture
EndFunc

Func _GDIPlus_TextureGetWidth(ByRef $texture)
	Return $texture[$TEXTURE_WIDTH]
EndFunc

Func _GDIPlus_TextureGetHeight(ByRef $texture)
	Return $texture[$TEXTURE_HEIGHT]
EndFunc

Func _GDIPlus_TextureGetHandle(ByRef $texture)
	return $texture[$TEXTURE_HANDLE]
EndFunc

Func phys_DrawPolygonGDIPlus($polygon_id)
	
	_GDIPlus_GraphicsClear($g_hFGBackbuffer, 0x0)
	
	Local $hMatrix = _GDIPlus_MatrixCreate()
	
	_GDIPlus_MatrixTranslate($hMatrix, $g_FGBitmapSize[0] / 2, $g_FGBitmapSize[1] / 2)
	_GDIPlus_MatrixRotate($hMatrix, $g_Polygons_Angle[$polygon_id] * $RAD_TO_DEG, False)
	
	_GDIPlus_GraphicsSetTransform($g_hFGBackbuffer, $hMatrix)
	
	Local $texture = $g_Polygons_Texture[$polygon_id]
	
	DllCall($ghGDIPDll, "int", "GdipFillPolygonI", "hWnd", $g_hFGBackbuffer, "hWnd", $texture[$TEXTURE_HANDLE], "ptr", DllStructGetPtr($g_Polygons_Points_Struct[$polygon_id]), "int", $g_Polygons_NumPoints[$polygon_id], "int", "FillModeAlternate")
	
	DllCall($ghGDIPDll, "int", "GdipDrawPolygonI", "handle", $g_hFGBackbuffer, "handle", $g_hPen, "ptr", DllStructGetPtr($g_Polygons_Points_Struct[$polygon_id]), "int", $g_Polygons_NumPoints[$polygon_id])
	
	_GDIPlus_MatrixDispose($hMatrix)
	
	;TODO
	
	_GDIPlus_GraphicsDrawImageRect($g_hBackbuffer, $g_hFGBitmap, $g_Polygons_Position_X[$polygon_id] - $g_FGBitmapSize[0] / 2, $g_Polygons_Position_Y[$polygon_id] - $g_FGBitmapSize[1] / 2, $g_FGBitmapSize[0], $g_FGBitmapSize[1]) ;copy foreground backbuffer to main backbuffer
		
	If $PHYS_DRAW_COLLISION_CIRCLES Then DllCall($ghGDIPDll, "int", "GdipDrawEllipseI", "handle", $g_hBackbuffer, "handle", $g_hPen, "int", $g_Polygons_Position_X[$polygon_id] - $g_Polygons_Radius[$polygon_id], "int", $g_Polygons_Position_Y[$polygon_id] - $g_Polygons_Radius[$polygon_id], "int", $g_Polygons_Radius[$polygon_id] * 2, "int", $g_Polygons_Radius[$polygon_id] * 2)
	If $PHYS_DRAW_COLLISION_BOXES Then 
		Local $BoxWidth  = $g_Polygons_Box_X_Max[$polygon_id] - $g_Polygons_Box_X_Min[$polygon_id]
		Local $BoxHeight = $g_Polygons_Box_Y_Max[$polygon_id] - $g_Polygons_Box_Y_Min[$polygon_id]
		_GDIPlus_GraphicsDrawRect( $g_hBackbuffer, $g_Polygons_Box_X_Min[$polygon_id], $g_Polygons_Box_Y_Min[$polygon_id], $BoxWidth, $BoxHeight, $g_hPen )
	EndIf
EndFunc

Func phys_DrawPolygonOpengl($polygon_id, Const ByRef $Points_X, Const ByRef $Points_Y, Const ByRef $Points_Translated_X, Const ByRef $Points_Translated_Y )
	
	Local $Scale = 4
	
	glColor3f(1, 1, 1)
	glBindTexture($GL_TEXTURE_2D, $g_Polygons_Texture[$polygon_id])
	
	glBegin($GL_TRIANGLE_FAN)
	
	glTexCoord2f(0, 0)
	glVertex2f($g_Polygons_Position_X[$polygon_id], $g_Polygons_Position_Y[$polygon_id])
	;MsgBox(0,"",$g_Polygons_Position_X[$polygon_id] * $g_Window_Width & " " & $g_Polygons_Position_Y[$polygon_id] * $g_Window_Height)
	;Local $NumElements = 2 * $g_Polygons_NumPoints[$polygon_id]
	
	For $i = 0 To $g_Polygons_NumPoints[$polygon_id] - 1 Step 1
		glTexCoord2f($Points_X[$i] / $g_Window_Width * $Scale, $Points_Y[$i] / $g_Window_Height * $Scale)
		glVertex2f($Points_Translated_X[$i], $Points_Translated_Y[$i])
		;MsgBox(0,"",$g_Polygons_Points_Translated[$polygon_id][$i] * $g_Window_Width & " " & $g_Polygons_Points_Translated[$polygon_id][$i+1] * $g_Window_Height)
	Next
	
	glTexCoord2f($Points_X[0] / $g_Window_Width * $Scale, $Points_Y[0] / $g_Window_Height * $Scale)
	glVertex2f($Points_Translated_X[0], $Points_Translated_Y[0])
	
	glEnd()
	
EndFunc

Func phys_DrawCrossOpengl($position_x, $position_y)
	
	Local $CrossSize = 5

	glColor3f(0, 0, 0)
	
	glBegin($GL_LINES)
	
	glVertex2f($position_x - $CrossSize, $position_y)
	glVertex2f($position_x + $CrossSize, $position_y)
	glVertex2f($position_x, $position_y - $CrossSize)
	glVertex2f($position_x, $position_y + $CrossSize)
	
	glEnd()
	
EndFunc

Func phys_DrawCrossGDIPlus($position_x, $position_y)
	Local $CrossSize = 5

	_GDIPlus_GraphicsDrawLine($g_hBackbuffer,$position_x-$CrossSize,$position_y,$position_x+$CrossSize,$position_y, $g_hPen)
	_GDIPlus_GraphicsDrawLine($g_hBackbuffer,$position_x,$position_y-$CrossSize,$position_x,$position_y+$CrossSize, $g_hPen)
EndFunc

Func phys_DrawLineOpengl( $x1, $y1, $x2, $y2 )
	
	glColor3f(0, 0, 0)
	
	glBegin($GL_LINES)
	
	glVertex2f($x1, $y1)
	glVertex2f($x2, $y2)
	
	glEnd()
	
EndFunc

Func phys_DrawLineGDIPlus( $x1, $y1, $x2, $y2 )
	
	_GDIPlus_GraphicsDrawLine($g_hBackbuffer,$x1, $y1, $x2, $y2, $g_hPen)

EndFunc

Func phys_DrawCircle($circle_id)
	
	_GDIPlus_GraphicsClear($g_hFGBackbuffer, 0x0)
	
	Local $hMatrix = _GDIPlus_MatrixCreate()
	
	_GDIPlus_MatrixTranslate($hMatrix, $g_FGBitmapSize[0] / 2, $g_FGBitmapSize[1] / 2)
	_GDIPlus_MatrixRotate($hMatrix, $g_Circles_Angle[$circle_id] * $RAD_TO_DEG, False)
	
	_GDIPlus_GraphicsSetTransform($g_hFGBackbuffer, $hMatrix)
	
	Local $texture = $g_Polygons_Texture[$circle_id]
	
	DllCall($ghGDIPDll, "int", "GdipFillEllipseI", "handle", $g_hFGBackbuffer, "handle", $texture[$TEXTURE_HANDLE], "int", - $g_Circles_Radius[$circle_id], "int", - $g_Circles_Radius[$circle_id], "int", $g_Circles_Radius[$circle_id] * 2, "int", $g_Circles_Radius[$circle_id] * 2)
	
	_GDIPlus_MatrixDispose($hMatrix)
	
	_GDIPlus_GraphicsDrawImageRect($g_hBackbuffer, $g_hFGBitmap, $g_Circles_Position_X[$circle_id] - $g_FGBitmapSize[0] / 2, $g_Circles_Position_Y[$circle_id] - $g_FGBitmapSize[1] / 2, $g_FGBitmapSize[0], $g_FGBitmapSize[1]) ;copy foreground backbuffer to main backbuffer
	
	DllCall($ghGDIPDll, "int", "GdipDrawEllipseI", "handle", $g_hBackbuffer, "handle", $g_hPen, "int", $g_Circles_Position_X[$circle_id] - $g_Circles_Radius[$circle_id], "int", $g_Circles_Position_Y[$circle_id] - $g_Circles_Radius[$circle_id], "int", $g_Circles_Radius[$circle_id] * 2, "int", $g_Circles_Radius[$circle_id] * 2)
	
EndFunc

Func phys_ClearBackbuffer()
	_GDIPlus_GraphicsClear($g_hBackbuffer, $PHYS_DRAW_CLEARCOLOR)
EndFunc

Func phys_SwapBuffers()
	_WinAPI_BitBlt($g_hDC, 3, 23, $g_Window_Width, $g_Window_Height, $g_Backbuffer_hDC, 0, 0, $SRCCOPY) ;$SRCCOPY = 0x00CC0020
EndFunc
