;PhysicEngine_3_Opengl.au3
#include-once

#include <GDIPlus.au3>
#include <WinAPI.au3>

Global Const $GLenum                           = "UINT"
Global Const $GLboolean                        = "BYTE"
Global Const $GLbitfield                       = "UINT"
Global Const $GLbyte                           = "BYTE"
Global Const $GLshort                          = "short"
Global Const $GLint                            = "int"
Global Const $GLsizei                          = "int"
Global Const $GLubyte                          = "BYTE"
Global Const $GLushort                         = "USHORT"
Global Const $GLuint                           = "UINT"
Global Const $GLfloat                          = "float"
Global Const $GLclampf                         = "float"
Global Const $GLdouble                         = "double"
Global Const $GLclampd                         = "double"
Global Const $GLvoid                           = "none"

Global Const $GL_VERSION_1_1                   = 1
Global Const $PFD_TYPE_RGBA                    = 0
Global Const $PFD_MAIN_PLANE                   = 0
Global Const $PFD_DOUBLEBUFFER                 = 1
Global Const $PFD_DRAW_TO_WINDOW               = 4
Global Const $PFD_SUPPORT_OPENGL               = 32
Global Const $GL_COLOR_BUFFER_BIT              = 0x00004000

Global Const $GL_MODELVIEW                     = 0x1700
Global Const $GL_PROJECTION                    = 0x1701
Global Const $GL_TEXTURE                       = 0x1702

Global Const $GL_POINTS                        = 0x0000
Global Const $GL_LINES                         = 0x0001
Global Const $GL_LINE_LOOP                     = 0x0002
Global Const $GL_LINE_STRIP                    = 0x0003
Global Const $GL_TRIANGLES                     = 0x0004
Global Const $GL_TRIANGLE_STRIP                = 0x0005
Global Const $GL_TRIANGLE_FAN                  = 0x0006
Global Const $GL_QUADS                         = 0x0007
Global Const $GL_QUAD_STRIP                    = 0x0008
Global Const $GL_POLYGON                       = 0x0009

Global Const $GL_RGB                           = 0x1907
Global Const $GL_RGBA                          = 0x1908
Global Const $GL_BGR                           = 0x80E0
Global Const $GL_BGRA                          = 0x80E1

Global Const $GL_TEXTURE_MAG_FILTER            = 0x2800
Global Const $GL_TEXTURE_MIN_FILTER            = 0x2801
Global Const $GL_TEXTURE_WRAP_S                = 0x2802
Global Const $GL_TEXTURE_WRAP_T                = 0x2803
Global Const $GL_TEXTURE_WIDTH                 = 0x1000
Global Const $GL_TEXTURE_HEIGHT                = 0x1001
Global Const $GL_TEXTURE_INTERNAL_FORMAT       = 0x1003
Global Const $GL_TEXTURE_BORDER_COLOR          = 0x1004
Global Const $GL_TEXTURE_BORDER                = 0x1005
Global Const $GL_NEAREST                       = 0x2600
Global Const $GL_LINEAR                        = 0x2601
Global Const $GL_CLAMP                         = 0x2900
Global Const $GL_REPEAT                        = 0x2901
Global Const $GL_TEXTURE_1D                    = 0x0DE0
Global Const $GL_TEXTURE_2D                    = 0x0DE1

Global Const $GL_BYTE                          = 0x1400
Global Const $GL_UNSIGNED_BYTE                 = 0x1401
Global Const $GL_SHORT                         = 0x1402
Global Const $GL_UNSIGNED_SHORT                = 0x1403
Global Const $GL_INT                           = 0x1404
Global Const $GL_UNSIGNED_INT                  = 0x1405
Global Const $GL_FLOAT                         = 0x1406
Global Const $GL_2_BYTES                       = 0x1407
Global Const $GL_3_BYTES                       = 0x1408
Global Const $GL_4_BYTES                       = 0x1409
Global Const $GL_DOUBLE                        = 0x140A

Global Const $g_dll_opengl32 = DllOpen( "opengl32.dll" )
Global Const $g_dll_user32 = DllOpen( "user32.dll" )
Global Const $g_dll_gdi32 = DllOpen( "gdi32.dll" )

Func CreateOpenGLContext($hwnd, ByRef $hDC)
    
    Local $pfd = DllStructCreate("short nSize;" & _
            "short nVersion;" & _
            "dword dwFlags;" & _
            "byte  iPixelType;" & _
            "byte  cColorBits;" & _
            "byte  cRedBits;" & _
            "byte  cRedShift;" & _
            "byte  cGreenBits;" & _
            "byte  cGreenShift;" & _
            "byte  cBlueBits;" & _
            "byte  cBlueShift;" & _
            "byte  cAlphaBits;" & _
            "byte  cAlphaShift;" & _
            "byte  cAccumBits;" & _
            "byte  cAccumRedBits;" & _
            "byte  cAccumGreenBits;" & _
            "byte  cAccumBlueBits;" & _
            "byte  cAccumAlphaBits;" & _
            "byte  cDepthBits;" & _
            "byte  cStencilBits;" & _
            "byte  cAuxBuffers;" & _
            "byte  iLayerType;" & _
            "byte  bReserved;" & _
            "dword dwLayerMask;" & _
            "dword dwVisibleMask;" & _
            "dword dwDamageMask;")
	
	DllStructSetData($pfd, "nSize", DllStructGetSize($pfd))
    DllStructSetData($pfd, "nVersion", $GL_VERSION_1_1)
    DllStructSetData($pfd, "dwFlags", BitOR($PFD_DRAW_TO_WINDOW, $PFD_SUPPORT_OPENGL, $PFD_DOUBLEBUFFER))
    DllStructSetData($pfd, "iPixelType", $PFD_TYPE_RGBA)
    DllStructSetData($pfd, "cColorBits", 24)
    DllStructSetData($pfd, "cDepthBits", 16)
    DllStructSetData($pfd, "iLayerType", $PFD_MAIN_PLANE)
	
    $hDC = _WinAPI_GetDC($hwnd)    

    Local $iFormat = ChoosePixelFormat( $hDC, $pfd )
    
    If Not SetPixelFormat( $hDC, $iFormat, $pfd ) Then Return False

    Local $hGLRC = wglCreateContext( $hDC)
    
    If Not wglMakeCurrent( $hDC, $hGLRC ) Then Return False
    
    Return True
EndFunc   ;==>CreateOpenGLContext

Func ChoosePixelFormat($hdc, $ppfd)
	Local $iFormat = DllCall($g_dll_gdi32, "int", "ChoosePixelFormat", "hwnd", $hdc, "ptr", DllStructGetPtr($ppfd))
	If @error Then Return SetError(@error, @extended, 0)
	Return $iFormat[0]	
EndFunc   ;==>ChoosePixelFormat

Func SetPixelFormat( $hdc, $iPixelFormat, $ppfd )
	Local $bResult = DllCall($g_dll_gdi32, "int", "SetPixelFormat", "hwnd", $hdc, "int", $iPixelFormat, "ptr", DllStructGetPtr($ppfd))
	If @error Then Return SetError(@error, @extended, 0)
	Return $bResult[0]	
EndFunc   ;==>SetPixelFormat

Func wglCreateContext( $hdc )
	Local $hGLRC = DllCall($g_dll_opengl32, "hwnd", "wglCreateContext", "hwnd", $hdc)
	If @error Then Return SetError(@error, @extended, 0)
	Return $hGLRC[0]	
EndFunc   ;==>wglCreateContext

Func wglMakeCurrent( $hdc, $hglrc )
	Local $bResult = DllCall($g_dll_opengl32, "int", "wglMakeCurrent", "int", $hdc, "int", $hglrc)
	If @error Then Return SetError(@error, @extended, 0)
	Return $bResult[0]	
EndFunc   ;==>wglMakeCurrent

Func glBegin($mode)
    DllCall($g_dll_opengl32, "none", "glBegin", "uint", $mode)
EndFunc   ;==>glBegin

Func glClear($mask)
    DllCall($g_dll_opengl32, "none", "glClear", "uint", $mask)
EndFunc   ;==>glClear

Func glColor3f($red, $green, $blue)
    DllCall($g_dll_opengl32, "none", "glColor3f", "float", $red, "float", $green, "float", $blue)
EndFunc   ;==>glColor3f

Func glEnd()
    DllCall($g_dll_opengl32, "none", "glEnd")
EndFunc   ;==>glEnd

Func glMatrixMode($mode)
    DllCall($g_dll_opengl32, "none", "glMatrixMode", "uint", $mode)
EndFunc   ;==>glMatrixMode

Func glTranslatef( $x, $y, $z )
	DllCall($g_dll_opengl32, "none", "glTranslatef", $GLfloat, $x, $GLfloat, $y, $GLfloat, $z)
EndFunc

Func glRotatef( $angle, $x, $y, $z )
	DllCall($g_dll_opengl32, "none", "glRotatef", $GLfloat, $angle, $GLfloat, $x, $GLfloat, $y, $GLfloat, $z)
EndFunc

Func glScalef( $x, $y, $z )
	DllCall($g_dll_opengl32, "none", "glScalef", $GLfloat, $x, $GLfloat, $y, $GLfloat, $z)
EndFunc

Func glLoadIdentity()
	DllCall($g_dll_opengl32, "none", "glLoadIdentity")
EndFunc

Func glVertex2f($x, $y)
    DllCall($g_dll_opengl32, "none", "glVertex2f", "float", $x, "float", $y)
EndFunc   ;==>glVertex2f

Func glVertex3f($x, $y, $z)
    DllCall($g_dll_opengl32, "none", "glVertex3f", "float", $x, "float", $y, "float", $z)
EndFunc   ;==>glVertex3f

Func glTexCoord2f($s,$t)
	DllCall($g_dll_opengl32, "none", "glTexCoord2f", $GLfloat, $s, $GLfloat, $t)
EndFunc   ;==>glVertex3f

Func glViewport($x, $y, $width, $height)
	DllCall($g_dll_opengl32, "none", "glViewport", "int", $x, "int", $y, "int", $width, "int", $height)
EndFunc   ;==>glViewport

Func glGenTextures($n, ByRef $textures)
	Local $struct = DllStructCreate( "UINT[" & $n & "]" )	
	
	DllCall($g_dll_opengl32, "none", "glGenTextures", "int", $n, "struct*", $struct )
	If @error Then Return SetError(@error, @extended, False)
	
	For $i = 0 To $n-1 Step 1
		$textures[$i] = DllStructGetData($struct, 1, $i+1)
	Next
	
	Return True
EndFunc   ;==>glVertex3f

Func glBindTexture($target, $texture)
	DllCall($g_dll_opengl32, "none", "glBindTexture", $GLenum, $target, $GLuint, $texture )
	If @error Then MsgBox(0,"","error"); Return SetError(@error, @extended, False)
EndFunc   ;==>glVertex3f

Func glTexParameteri($target, $pname, $param)
	DllCall($g_dll_opengl32, "none", "glTexParameteri", $GLenum, $target, $GLenum, $pname, $GLint, $param)	
EndFunc   ;==>glVertex3f

Func glTexParameterf($target, $pname, $param)
	DllCall($g_dll_opengl32, "none", "glTexParameterf", $GLenum, $target, $GLenum, $pname, $GLfloat, $param)	
EndFunc   ;==>glVertex3f

Func glGetTexLevelParameteriv( $target, $level, $pname, ByRef $params )
	Local $struct = DllStructCreate( "int" )

	DllCall($g_dll_opengl32, "none", "glGetTexLevelParameteriv", $GLenum, $target, $GLint, $pname, $GLenum, $params, "struct*", $struct)	
	
	$params = DllStructGetData( $struct, 1 )
EndFunc

Func GetPixel( $hdc, $nXPos, $nYPos )
	Local $Pixel = DllCall($g_dll_gdi32, "int", "SetPixelFormat", "hwnd", $hdc, "int", $nXPos, "int", $nYPos)
	If @error Then Return SetError(@error, @extended, 0)
	Return $Pixel[0]	
EndFunc   ;==>GetPixel

Func glCreateTextureFromFileFast( $FileName )
	Local $TextureWidth = 0, $TextureHeight = 0, $TextureID = 0
	glCreateTextureFromFile( $filename, $TextureWidth, $TextureHeight, $TextureID )
	Return $TextureID
EndFunc

Func glCreateTextureFromFile( $FileName, ByRef $width, ByRef $height, ByRef $texture_id )
		
	_GDIPlus_Startup()
	
	Local $hBitmap = _GDIPlus_BitmapCreateFromFile( $FileName )
	
	If $hBitmap = 0 Then Return False
	
	$width = _GDIPlus_ImageGetWidth($hBitmap)
	$height = _GDIPlus_ImageGetHeight($hBitmap)
	
	Local $BitmapData = _GDIPlus_BitmapLockBits( $hBitmap, 0, 0, $width-1, $height-1, BitOR($GDIP_ILMREAD, $GDIP_ILMWRITE), $GDIP_PXF32RGB  )
		
	Local $TextureID[1] = [0]
	glGenTextures( 1, $TextureID )
	glBindTexture( $GL_TEXTURE_2D, $TextureID[0] )

	glTexParameterf( $GL_TEXTURE_2D, $GL_TEXTURE_MIN_FILTER, $GL_LINEAR )
	glTexParameterf( $GL_TEXTURE_2D, $GL_TEXTURE_MAG_FILTER, $GL_LINEAR )

	glTexParameterf( $GL_TEXTURE_2D, $GL_TEXTURE_WRAP_S, $GL_REPEAT );
	glTexParameterf( $GL_TEXTURE_2D, $GL_TEXTURE_WRAP_T, $GL_REPEAT );
	
	glTexImage2D( $GL_TEXTURE_2D, 0, $GL_RGB, $width, $height, 0, $GL_BGRA, $GL_UNSIGNED_BYTE, DllStructGetData( $BitmapData, "Scan0" ) )
		
	_GDIPlus_BitmapUnlockBits( $hBitmap, $BitmapData )
	
	_GDIPlus_BitmapDispose( $hBitmap )
	
	_GDIPlus_Shutdown()
	
	$texture_id = $TextureID[0]
	
	Return True
EndFunc   ;==>glCreateTextureFromFile

Func glCreateTextureFromFile_if_GL_BGRA_not_supported( $FileName, ByRef $width, ByRef $height, ByRef $texture_id )
	
	_GDIPlus_Startup()
	
	Local $Bitmap = _GDIPlus_BitmapCreateFromFile( @ScriptDir & "\Images\Plastik.jpg" )
	
	If $hBitmap = 0 Then Return False
	
	Local $hBitmap = _GDIPlus_BitmapCreateHBITMAPFromBitmap( $Bitmap )
	$width = _GDIPlus_ImageGetWidth($Bitmap)
	$height = _GDIPlus_ImageGetHeight($Bitmap)
	
	_GDIPlus_Shutdown()	
	
	Local $hDC = _WinAPI_GetDC(0)
    Local $hMemDC = _WinAPI_CreateCompatibleDC($hDC)
    _WinAPI_ReleaseDC(0, $hDC)
    _WinAPI_SelectObject($hMemDC,$hBitmap)    

	Local $Pixel = DllStructCreate( "UINT[" & $width * $height & "]" )
	
	Local $i = 1
	
	For $x = 0 To $width-1 Step 1
		For $y= 0 To $height-1 Step 1
			Local $Color = DLLCall("gdi32.dll","int","GetPixel","int",$hMemDC ,"int",$x,"int",$y)
			DllStructSetData( $Pixel, 1, $Color[0], $i )
			$i += 1
		Next
	Next
		
	_WinAPI_DeleteDC($hMemDC)
		
	_GDIPlus_BitmapDispose( $Bitmap )
	
	_GDIPlus_Shutdown()
		
	Local $TextureID[1] = [0]
	glGenTextures( 1, $TextureID )
	glBindTexture( $GL_TEXTURE_2D, $TextureID[0] )
	
	glTexParameterf( $GL_TEXTURE_2D, $GL_TEXTURE_MIN_FILTER, $GL_LINEAR )
	glTexParameterf( $GL_TEXTURE_2D, $GL_TEXTURE_MAG_FILTER, $GL_LINEAR )

	glTexParameterf( $GL_TEXTURE_2D, $GL_TEXTURE_WRAP_S, $GL_REPEAT );
	glTexParameterf( $GL_TEXTURE_2D, $GL_TEXTURE_WRAP_T, $GL_REPEAT );
		
	DllCall($g_dll_opengl32, "none", "glTexImage2D", _ 
		$GLenum, $GL_TEXTURE_2D, _ 
		$GLint, 0, _ 
		$GLint, $GL_RGB, _ 
		$GLsizei, $width, _ 
		$GLsizei, $height, _ 
		$GLint, 0, _ 
		$GLint, $GL_RGBA, _ 
		$GLenum, $GL_UNSIGNED_BYTE, _ 
		"struct*", $Pixel )
			
	$texture_id = $TextureID[0]
	
	Return True
EndFunc   ;==>glCreateTextureFromFile_if_GL_BGRA_not_supported

Func glCreateTextureFromColorFast( $Color )
	Local $TextureWidth = 64, $TextureHeight = 64, $TextureID = 0
	glCreateTextureFromColor( $Color, $TextureWidth, $TextureHeight, $TextureID )
	Return $TextureID
EndFunc

Func glCreateTextureFromColor( $Color, $width, $height, ByRef $texture_id )

	Local $Pixel = DllStructCreate( "UINT[" & $width * $height & "]" )
	
	Local $i = 1
	
	For $x = 0 To $width-1 Step 1
		For $y= 0 To $height-1 Step 1
			DllStructSetData( $Pixel, 1, $Color, $i )
			$i += 1
		Next
	Next
			
	Local $TextureID[1] = [0]
	glGenTextures( 1, $TextureID )
	glBindTexture( $GL_TEXTURE_2D, $TextureID[0] )
	
	glTexParameterf( $GL_TEXTURE_2D, $GL_TEXTURE_MIN_FILTER, $GL_LINEAR )
	glTexParameterf( $GL_TEXTURE_2D, $GL_TEXTURE_MAG_FILTER, $GL_LINEAR )

	glTexParameterf( $GL_TEXTURE_2D, $GL_TEXTURE_WRAP_S, $GL_REPEAT );
	glTexParameterf( $GL_TEXTURE_2D, $GL_TEXTURE_WRAP_T, $GL_REPEAT );
		
	DllCall($g_dll_opengl32, "none", "glTexImage2D", _ 
		$GLenum, $GL_TEXTURE_2D, _ 
		$GLint, 0, _ 
		$GLint, $GL_RGB, _ 
		$GLsizei, $width, _ 
		$GLsizei, $height, _ 
		$GLint, 0, _ 
		$GLint, $GL_RGBA, _ 
		$GLenum, $GL_UNSIGNED_BYTE, _ 
		"struct*", $Pixel )
			
	$texture_id = $TextureID[0]
	
	Return True
EndFunc   ;==>glCreateTextureFromFile_if_GL_BGRA_not_supported

Func glTexImage2D( $target, $level, $internalformat, $width, $height, $border, $format, $type, $pixels )
	DllCall($g_dll_opengl32, "none", "glTexImage2D", _ 
		$GLenum, $target, _ 
		$GLint, $level, _ 
		$GLint, $internalformat, _ 
		$GLsizei, $width, _ 
		$GLsizei, $height, _ 
		$GLint, $border, _ 
		$GLint, $format, _ 
		$GLenum, $type, _ 
		"ptr", $pixels )
EndFunc   ;==>glTexImage2D

Func glEnable( $cap )
	DllCall($g_dll_opengl32, "none", "glEnable", $GLenum, $cap)
EndFunc   ;==>glEnable

Func glDisable( $cap )
	DllCall($g_dll_opengl32, "none", "glDisable", $GLenum, $cap)
EndFunc

Func glClearColor( $red, $green, $blue, $alpha )
	DllCall($g_dll_opengl32, "none", "glClearColor", $GLclampf, $red, $GLclampf, $green, $GLclampf, $blue, $GLclampf, $alpha)
EndFunc

Func SwapBuffers($hDC)
    DllCall($g_dll_gdi32, "int", "SwapBuffers", "hwnd", $hDC)
EndFunc   ;==>SwapBuffers