;PhysicEngine_3_Settings.au3

#include-once
#include <WindowsConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <PhysicEngine_3_Declarations.au3>

Global $PHYS_GRAVITY_X = 0
Global $PHYS_GRAVITY_Y = 0
Global $PHYS_DAMPING_COEFFICIENT = 0.99
Global $PHYS_CORRECT_POSITION = True
Global $PHYS_FRICTION = True
Global $PHYS_IMPULS_COEFFICIENT = 0.6
Global $PHYS_SLEEP_MAX_MOVEMENT_SQ = 5*5
Global $PHYS_SLEEP_MAX_ANGLE = 5
Global $PHYS_SLEEP_TIME = 3
Global $PHYS_DEBUG = False
Global $PHYS_DRAW_INFORMATION = False
Global $PHYS_DRAW_CLEARCOLOR = 0xFF819FF7
Global $PHYS_DRAW_MODE = $RENDER_GDIPLUS
Global $PHYS_DRAW_COLLISION_BOXES = False
Global $PHYS_DRAW_COLLISION_CIRCLES = False
Global $PHYS_FIX_TIMESTEP_S = 0.03333333

Global $g_DebugWindow_hWnd
Global $g_DebugWindow_Controls[20]
Global $g_DebugWindow_Info

Global Const $PHYS_SETTINGS_FILE = @ScriptDir & "\phys_Settings.ini"

Func phys_SaveSettings()
	IniWrite( $PHYS_SETTINGS_FILE, "Settings", "GravityX", $PHYS_GRAVITY_X )
	IniWrite( $PHYS_SETTINGS_FILE, "Settings", "GravityY", $PHYS_GRAVITY_Y )
	IniWrite( $PHYS_SETTINGS_FILE, "Settings", "DampingCoefficient", $PHYS_DAMPING_COEFFICIENT )
	If Not $PHYS_CORRECT_POSITION Then IniWrite( $PHYS_SETTINGS_FILE, "Settings", "CorrectPositions", 0 )
	If $PHYS_CORRECT_POSITION Then IniWrite( $PHYS_SETTINGS_FILE, "Settings", "CorrectPositions", 1 )
	If Not $PHYS_FRICTION Then IniWrite( $PHYS_SETTINGS_FILE, "Settings", "Friction", 0 )
	If $PHYS_FRICTION Then IniWrite( $PHYS_SETTINGS_FILE, "Settings", "Friction", 1 )
	IniWrite( $PHYS_SETTINGS_FILE, "Settings", "ImpulseCoefficient", $PHYS_IMPULS_COEFFICIENT )
	IniWrite( $PHYS_SETTINGS_FILE, "Settings", "SleepMaxMovementSQ", $PHYS_SLEEP_MAX_MOVEMENT_SQ )
	IniWrite( $PHYS_SETTINGS_FILE, "Settings", "SleepMaxAngle", $PHYS_SLEEP_MAX_ANGLE )
	IniWrite( $PHYS_SETTINGS_FILE, "Settings", "SleepTime", $PHYS_SLEEP_TIME )
	If Not $PHYS_DEBUG Then IniWrite( $PHYS_SETTINGS_FILE, "Settings", "Debug", 0 )
	If $PHYS_DEBUG Then IniWrite( $PHYS_SETTINGS_FILE, "Settings", "Debug", 1 )
	If Not $PHYS_DRAW_INFORMATION Then IniWrite( $PHYS_SETTINGS_FILE, "Settings", "DrawInformations", 0 )
	If $PHYS_DRAW_INFORMATION Then IniWrite( $PHYS_SETTINGS_FILE, "Settings", "DrawInformations", 1 )
	IniWrite( $PHYS_SETTINGS_FILE, "Settings", "DrawClearColor", $PHYS_DRAW_CLEARCOLOR )
	IniWrite( $PHYS_SETTINGS_FILE, "Settings", "DrawMode", $PHYS_DRAW_MODE )
	If Not $PHYS_DRAW_COLLISION_BOXES Then IniWrite( $PHYS_SETTINGS_FILE, "Settings", "DrawCollisionBoxes", 0 )
	If $PHYS_DRAW_COLLISION_BOXES Then IniWrite( $PHYS_SETTINGS_FILE, "Settings", "DrawCollisionBoxes", 1 )
	If Not $PHYS_DRAW_COLLISION_CIRCLES Then IniWrite( $PHYS_SETTINGS_FILE, "Settings", "DrawCollisionCircles", 0 )
	If $PHYS_DRAW_COLLISION_CIRCLES Then IniWrite( $PHYS_SETTINGS_FILE, "Settings", "DrawCollisionCircles", 1 )
	IniWrite( $PHYS_SETTINGS_FILE, "Settings", "FixTimeStepS", $PHYS_FIX_TIMESTEP_S )
EndFunc

Func phys_LoadSettings()
	$PHYS_GRAVITY_X               = IniRead( $PHYS_SETTINGS_FILE, "Settings", "GravityX", 0 )
	$PHYS_GRAVITY_Y               = IniRead( $PHYS_SETTINGS_FILE, "Settings", "GravityY", 98.1 )
	$PHYS_DAMPING_COEFFICIENT     = IniRead( $PHYS_SETTINGS_FILE, "Settings", "DampingCoefficient", 0.99 )
	$PHYS_CORRECT_POSITION        = (IniRead( $PHYS_SETTINGS_FILE, "Settings", "CorrectPositions", 1 ) = 1)
	$PHYS_FRICTION                = (IniRead( $PHYS_SETTINGS_FILE, "Settings", "Friction", 1 ) = 1)
	$PHYS_IMPULS_COEFFICIENT      = IniRead( $PHYS_SETTINGS_FILE, "Settings", "ImpulseCoefficient", 0.6 )
	$PHYS_SLEEP_MAX_MOVEMENT_SQ   = IniRead( $PHYS_SETTINGS_FILE, "Settings", "SleepMaxMovementSQ", 5*5 )
	$PHYS_SLEEP_MAX_ANGLE         = IniRead( $PHYS_SETTINGS_FILE, "Settings", "SleepMaxAngle", 5 )
	$PHYS_SLEEP_TIME              = IniRead( $PHYS_SETTINGS_FILE, "Settings", "SleepTime", 3 )
	$PHYS_DEBUG                   = (IniRead( $PHYS_SETTINGS_FILE, "Settings", "Debug", 0 ) = 1)
	$PHYS_DRAW_INFORMATION        = (IniRead( $PHYS_SETTINGS_FILE, "Settings", "DrawInformations", 0 ) = 1)
	$PHYS_DRAW_CLEARCOLOR         = IniRead( $PHYS_SETTINGS_FILE, "Settings", "DrawClearColor", 0xFF819FF7 )
	$PHYS_DRAW_MODE               = IniRead( $PHYS_SETTINGS_FILE, "Settings", "DrawMode", $RENDER_GDIPLUS )
	$PHYS_DRAW_COLLISION_BOXES    = (IniRead( $PHYS_SETTINGS_FILE, "Settings", "DrawCollisionBoxes", 0 ) = 1)
	$PHYS_DRAW_COLLISION_CIRCLES  = (IniRead( $PHYS_SETTINGS_FILE, "Settings", "DrawCollisionCircles", 0 ) = 1)
	$PHYS_FIX_TIMESTEP_S          = IniRead( $PHYS_SETTINGS_FILE, "Settings", "FixTimeStepS", 0.03333333 )
EndFunc

Func phys_CreateDebugWindow($hwnd = 0)
	$g_DebugWindow_hWnd = GUICreate( "PhysicEngineDebug", 300, 800, 0, 0 )
		GUISetOnEvent(-3, "_phys_Exit")
	
	Local $x = 20
	Local $y = 20
	Local Const $OFFSET_VALUE_X = 20
	Local Const $OFFSET_ELEMENT_Y = 25
	Local Const $ELEMENT_WIDTH = 150
	Local Const $ELEMENT_HEIGHT = 25
	Local Const $LABEL_WIDTH = 280
	Local Const $LABEL_HEIGHT = 120
	Local Const $LABEL_2_HEIGHT = 250
	
	Local $i = 0
	
	$g_DebugWindow_Controls[$i] = _phys_DebugWindowCreateEdit( "GravityX:", $PHYS_GRAVITY_X, $x, $y, $ELEMENT_WIDTH, $ELEMENT_HEIGHT, $OFFSET_VALUE_X, $OFFSET_ELEMENT_Y, $i )
	$g_DebugWindow_Controls[$i] = _phys_DebugWindowCreateEdit( "GravityY:", $PHYS_GRAVITY_Y, $x, $y, $ELEMENT_WIDTH, $ELEMENT_HEIGHT, $OFFSET_VALUE_X, $OFFSET_ELEMENT_Y, $i )
	$g_DebugWindow_Controls[$i] = _phys_DebugWindowCreateEdit( "DampingCoefficient:", $PHYS_DAMPING_COEFFICIENT, $x, $y, $ELEMENT_WIDTH, $ELEMENT_HEIGHT, $OFFSET_VALUE_X, $OFFSET_ELEMENT_Y, $i )
	$g_DebugWindow_Controls[$i] = _phys_DebugWindowCreateCheckbox( "CorrectPositions:", $PHYS_CORRECT_POSITION, $x, $y, $ELEMENT_WIDTH, $ELEMENT_HEIGHT, $OFFSET_VALUE_X, $OFFSET_ELEMENT_Y, $i )
	$g_DebugWindow_Controls[$i] = _phys_DebugWindowCreateCheckbox( "Friction:", $PHYS_FRICTION, $x, $y, $ELEMENT_WIDTH, $ELEMENT_HEIGHT, $OFFSET_VALUE_X, $OFFSET_ELEMENT_Y, $i )
	$g_DebugWindow_Controls[$i] = _phys_DebugWindowCreateEdit( "ImpulseCoefficient:", $PHYS_IMPULS_COEFFICIENT, $x, $y, $ELEMENT_WIDTH, $ELEMENT_HEIGHT, $OFFSET_VALUE_X, $OFFSET_ELEMENT_Y, $i )
	$g_DebugWindow_Controls[$i] = _phys_DebugWindowCreateEdit( "SleepMaxMovementSQ:", $PHYS_SLEEP_MAX_MOVEMENT_SQ, $x, $y, $ELEMENT_WIDTH, $ELEMENT_HEIGHT, $OFFSET_VALUE_X, $OFFSET_ELEMENT_Y, $i )
	$g_DebugWindow_Controls[$i] = _phys_DebugWindowCreateEdit( "SleepMaxAngle:", $PHYS_SLEEP_MAX_ANGLE, $x, $y, $ELEMENT_WIDTH, $ELEMENT_HEIGHT, $OFFSET_VALUE_X, $OFFSET_ELEMENT_Y, $i )
	$g_DebugWindow_Controls[$i] = _phys_DebugWindowCreateEdit( "SleepTime:", $PHYS_SLEEP_TIME, $x, $y, $ELEMENT_WIDTH, $ELEMENT_HEIGHT, $OFFSET_VALUE_X, $OFFSET_ELEMENT_Y, $i )
	$g_DebugWindow_Controls[$i] = _phys_DebugWindowCreateCheckbox( "Debug:", $PHYS_DEBUG, $x, $y, $ELEMENT_WIDTH, $ELEMENT_HEIGHT, $OFFSET_VALUE_X, $OFFSET_ELEMENT_Y, $i )
	$g_DebugWindow_Controls[$i] = _phys_DebugWindowCreateCheckbox( "DrawInformations:", $PHYS_DRAW_INFORMATION, $x, $y, $ELEMENT_WIDTH, $ELEMENT_HEIGHT, $OFFSET_VALUE_X, $OFFSET_ELEMENT_Y, $i )
	$g_DebugWindow_Controls[$i] = _phys_DebugWindowCreateEdit( "DrawClearColor:", "0x" & Hex( $PHYS_DRAW_CLEARCOLOR ), $x, $y, $ELEMENT_WIDTH, $ELEMENT_HEIGHT, $OFFSET_VALUE_X, $OFFSET_ELEMENT_Y, $i )
	$g_DebugWindow_Controls[$i] = _phys_DebugWindowCreateEdit( "DrawMode:", $PHYS_DRAW_MODE, $x, $y, $ELEMENT_WIDTH, $ELEMENT_HEIGHT, $OFFSET_VALUE_X, $OFFSET_ELEMENT_Y, $i )
	$g_DebugWindow_Controls[$i] = _phys_DebugWindowCreateCheckbox( "DrawCollisionBoxes:", $PHYS_DRAW_COLLISION_BOXES, $x, $y, $ELEMENT_WIDTH, $ELEMENT_HEIGHT, $OFFSET_VALUE_X, $OFFSET_ELEMENT_Y, $i )
	$g_DebugWindow_Controls[$i] = _phys_DebugWindowCreateCheckbox( "DrawCollisionCircles:", $PHYS_DRAW_COLLISION_CIRCLES, $x, $y, $ELEMENT_WIDTH, $ELEMENT_HEIGHT, $OFFSET_VALUE_X, $OFFSET_ELEMENT_Y, $i )
	$g_DebugWindow_Controls[$i] = _phys_DebugWindowCreateEdit( "FixTimeStepS:", $PHYS_FIX_TIMESTEP_S, $x, $y, $ELEMENT_WIDTH, $ELEMENT_HEIGHT, $OFFSET_VALUE_X, $OFFSET_ELEMENT_Y, $i )

	$g_DebugWindow_Info = GUICtrlCreateLabel( "Informations:", $x, $y, $LABEL_WIDTH, $LABEL_HEIGHT )
		$y += $LABEL_HEIGHT + $OFFSET_ELEMENT_Y
		
	Local $Info_Key = _
		"Controls: " & @LF & @LF & _ 
		"   + 'W' = Wake Body" & @LF & _ 
		"   + 'S' = Sleep Body" & @LF & _ 
		"   + 'A' = Rotate Body Clockwise" & @LF & _ 
		"   + 'D' = Rotate Body Anticlockwise" & @LF & _ 
		"   + 'K' = Increase Body Size X" & @LF & _ 
		"   + 'I' = Decrease Body Size X" & @LF & _ 
		"   + 'L' = Increase Body Size Y" & @LF & _ 
		"   + 'J' = Decrease Body Size Y" & @LF & _ 
		"   + 'R' = Reset Body Velocity" & @LF & _ 
		"   + 'E' = Erase Body" & @LF & _ 
		"   + 'Mouse Lelf' = Select/Accelerate Body" & @LF & _ 
		"   + 'Mouse Right' = Set Body Position" & @LF & _ 
		"   + 'Left' = Player Move Left" & @LF & _ 
		"   + 'Right' = Player Move Right" & @LF & _ 
		"   + 'Up' = Player Jump"
		
	GUICtrlCreateLabel( $Info_Key, $x, $y, $LABEL_WIDTH, $LABEL_2_HEIGHT )
		$y += $LABEL_HEIGHT + $OFFSET_ELEMENT_Y
		
	GUISetState(@SW_SHOW)	
EndFunc

Func _phys_DebugWindowCreateEdit($name, $value, $x, ByRef $y, $width, $height, $offset_value_x, $offset_y, ByRef $ID)
	GUICtrlCreateLabel( $name, $x, $y, $width, $height )
	Local $hEdit = GUICtrlCreateEdit( $value, $x + $width + $offset_value_x, $y, $width/2, $height, BitOr($ES_AUTOVSCROLL, $ES_AUTOHSCROLL))
		$y += $offset_y
		$ID += 1
	Return $hEdit
EndFunc

Func _phys_DebugWindowCreateCheckbox($name, $state, $x, ByRef $y, $width, $height, $offset_value_x, $offset_y, ByRef $ID)
	GUICtrlCreateLabel( $name, $x, $y, $width, $height )
	Local $hCheckbox = GUICtrlCreateCheckbox( "", $x + $width + $offset_value_x, $y, 20, 20 ) 
		If $state Then GUICtrlSetState ( $hCheckbox, $GUI_CHECKED )
		If Not $state Then GUICtrlSetState ( $hCheckbox, $GUI_UNCHECKED )
		$y += $offset_y
		$ID += 1
		
	Return $hCheckbox
EndFunc

Func phys_ReadDebugWindow()
	Local $i
	
	$PHYS_GRAVITY_X               = _phys_DebugWindowReadEdit( $g_DebugWindow_Controls[$i], $i )
	$PHYS_GRAVITY_Y               = _phys_DebugWindowReadEdit( $g_DebugWindow_Controls[$i], $i )
	$PHYS_DAMPING_COEFFICIENT     = _phys_DebugWindowReadEdit( $g_DebugWindow_Controls[$i], $i )
	$PHYS_CORRECT_POSITION        = _phys_DebugWindowReadCheckbox( $g_DebugWindow_Controls[$i], $i )
	$PHYS_FRICTION                = _phys_DebugWindowReadCheckbox( $g_DebugWindow_Controls[$i], $i )
	$PHYS_IMPULS_COEFFICIENT      = _phys_DebugWindowReadEdit( $g_DebugWindow_Controls[$i], $i )
	$PHYS_SLEEP_MAX_MOVEMENT_SQ   = _phys_DebugWindowReadEdit( $g_DebugWindow_Controls[$i], $i )
	$PHYS_SLEEP_MAX_ANGLE         = _phys_DebugWindowReadEdit( $g_DebugWindow_Controls[$i], $i )
	$PHYS_SLEEP_TIME              = _phys_DebugWindowReadEdit( $g_DebugWindow_Controls[$i], $i )
	$PHYS_DEBUG                   = _phys_DebugWindowReadCheckbox( $g_DebugWindow_Controls[$i], $i )
	$PHYS_DRAW_INFORMATION        = _phys_DebugWindowReadCheckbox( $g_DebugWindow_Controls[$i], $i )
	$PHYS_DRAW_CLEARCOLOR         = "0x" & Hex(_phys_DebugWindowReadEdit( $g_DebugWindow_Controls[$i], $i ), 8)
	$PHYS_DRAW_MODE               = _phys_DebugWindowReadEdit( $g_DebugWindow_Controls[$i], $i )
	$PHYS_DRAW_COLLISION_BOXES    = _phys_DebugWindowReadCheckbox( $g_DebugWindow_Controls[$i], $i )
	$PHYS_DRAW_COLLISION_CIRCLES  = _phys_DebugWindowReadCheckbox( $g_DebugWindow_Controls[$i], $i )
	$PHYS_FIX_TIMESTEP_S          = _phys_DebugWindowReadEdit( $g_DebugWindow_Controls[$i], $i )
EndFunc

Func _phys_DebugWindowReadEdit( $hEdit, ByRef $ID )
	$ID += 1
	Return GUICtrlRead( $hEdit )
EndFunc

Func _phys_DebugWindowReadCheckbox( $hCheckbox, ByRef $ID )
	$ID += 1
	Return (GUICtrlRead( $hCheckbox ) = $GUI_CHECKED)
EndFunc

Func phys_SetDamping( $damping )
	$g_Coefficient_Damping = $damping
EndFunc

Func phys_SetImpulseScale( $scale )
	$g_ImpulseScale = $scale
EndFunc

Func phys_SetGravity( $gravity_x, $gravity_y  )
	$g_Gravity[0] = $gravity_x
	$g_Gravity[1] = $gravity_y
EndFunc

Func phys_SetClearColor( $color )
	$g_ClearColor = $color
EndFunc